; calibration file for single order mode
; assuming we used cal_lxd_2.1_3.0

; calso, 161, flat, arc
pro calso, indx, flat, arc, box=box
@include

; 0 arc on
; 1 arc off
; 2-6 flat

  if not keyword_set(box) then box = [0,180,512,110]
  x0=box[0]
  y0 = box[1] 
  x1 = x0 + box[2] - 1 
  y1 = y0 + box[3] - 1

  badmask_box = (rdbdpx())[x0:x1,y0:y1]  ; the badpix map within the box
  edgecoeffs_lso_box = edgecoeffs_lso
  edgecoeffs_lso_box[0,*,*] = edgecoeffs_lso_box[0,*,*] - y0

  ; first read the flats
  nflat = 5
  ; read the first one
  i = 0
  fn = flatfn(indx+2+i)
  flati = ( readfits(flatfn(indx+2+i), /silent) )[x0:x1,y0:y1]
  nxnyn, flati, nx, ny, n

  ; make the arrays and fill it with the first flat
  flatarr = fltarr(nx, ny, nflat)
  flatarr[*,*,i] = flati
  
  ; loop over the other flats
  for i = 1, nflat-1 do $
    flatarr[*,*,i] = ( readfits(flatfn(indx+2+i), /silent) )[x0:x1,y0:y1]

  ; normalize them before averaging
  flatarrn = flatarr
  for i = 0, nflat-1 do $
   flatarrn[*,*,i] = flatarr[*,*,i]/median(flatarr[10:30,10:30,i])

  ; and fixpix them
  flatarrf = flatarrn
  for i = 0, nflat-1 do begin
   im = flatarrn[*,*,i]
   flatarrf[*,*,i] = fixbdpx_medianlay(im, $
     badmask_box, edgecoeffs_lso_box, norders_lso, xranges_lso, window_lso, $
     cancel = cancel)
  end

  ; average them
  medarr, flatarrf, flat

  ; blank out the parts beyond the order
  for j = 0, nx-1 do begin
    botedge = round( poly(j,edgecoeffs_lso_box[*,0,0]) )
    topedge = round( poly(j,edgecoeffs_lso_box[*,1,0]) )
    if botedge ge 1 then flat[j,0:botedge-1] = 1.    
    if topedge le (ny-1)  then flat[j,topedge+1:ny-1] = 1.    
  end

  arcon = (readfits(arcfn(indx+0,0), /silent))[x0:x1,y0:y1]
  arcoff = (readfits(arcfn(indx+1,1), /silent))[x0:x1,y0:y1]
  arc = (arcon - arcoff)/flat
  im = arc
  arc = fixbdpx_medianlay(im, $
     badmask_box, edgecoeffs_lso_box, norders_lso, xranges_lso, window_lso, $
     cancel = cancel)


end


pro testfixbdpix, flatfixfull, flatfix
@include

  badmaskfull = readfits(badpixmask)
  flatfull = readfits(flatfn(165))
  temp = flatfull
  flatfixfull = fixbdpx_medianLAY(temp, $
     badmaskfull, edgecoeffs_lso, norders_lso, xranges_lso, window_lso, $
     cancel = cancel)

  box = [0,180,512,110]
  x0=box[0]
  y0 = box[1] 
  x1 = x0 + box[2] - 1 
  y1 = y0 + box[3] - 1
  badmask = badmaskfull[x0:x1,y0:y1]
  flat = flatfull[x0:x1,y0:y1]
  edgecoeffs_lso_box = edgecoeffs_lso
  edgecoeffs_lso_box[0,*,*] = edgecoeffs_lso_box[0,*,*] - y0
  flatfix = fixbdpx_medianLAY(flat, $
     badmask, edgecoeffs_lso_box, norders_lso, xranges_lso, window_lso, $
     cancel = cancel)

end