;+
; NAME:
;  delfile
; PURPOSE:
;  Delete file
; DESCRIPTION:
;
; CATEGORY:
;  File I/O
; CALLING SEQUENCE:
;  delfile,file
; INPUTS:
;  file - File to be deleted.
; OPTIONAL INPUT PARAMETERS:
;
; KEYWORD INPUT PARAMETERS:
;
; OUTPUTS:
;
; KEYWORD OUTPUT PARAMETERS:
;
; COMMON BLOCKS:
;
; SIDE EFFECTS:
;
; RESTRICTIONS:
;
; PROCEDURE:
;
; MODIFICATION HISTORY:
;  99/11/14, Written by Marc W. Buie, Lowell Observatory, MacOS portions
;     written by David Osip, MIT.
;-
pro delfile,file

   if badpar(file,7,0,caller='DELFILE: (file) ') then return

   if not exists(file) then return

   case !version.os_family OF

      'unix': begin
         spawn,'rm '+file
      end

      'Windows': begin
         spawn,'del '+file
      end

      'MacOS': begin
         cd, current=path2file
         if exists(path2file+file) then filed=path2file+file else filed=file
         scriptdel=['tell current application to copy variable "filed" to file2del',$
                    'set temp1 to characters 1 thru -2 of file2del',$
                    'set temp1 to temp1 as string',$
                    'tell application "Finder"',$
                    'select file temp1 ',$
                    'delete selection',$
                    'end tell']           
          do_apple_script, scriptdel
      end

      'vms': begin
         message,!version.os_family+' is currently unsupported.'
      end

      else: begin
         message,!version.os_family+' is an unrecognized OS type.'
      end

   endcase

end
